Reset by default LD_LIBRARY_PATH in xds-project.conf
[src/xds/xds-agent.git] / scripts / get-syncthing.sh
index 3455122..433a88d 100755 (executable)
@@ -1,4 +1,21 @@
 #!/bin/bash
+ ###########################################################################
+# Copyright 2017-2018 IoT.bzh
+#
+# author: Sebastien Douheret <sebastien@iot.bzh>
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+###########################################################################
 
 # Configurable variables
 [ -z "$SYNCTHING_VERSION" ] && SYNCTHING_VERSION=0.14.28
@@ -6,7 +23,7 @@
 # XXX - may be cleanup
 # Used as temporary HACK while waiting merge of #165
 #[ -z "$SYNCTHING_INOTIFY_VERSION" ] && { SYNCTHING_INOTIFY_VERSION=master; SYNCTHING_INOTIFY_CMID=af6fbf9d63f95a0; }
-[ -z "$DESTDIR" ] && DESTDIR=/usr/local/bin
+[ -z "$DESTDIR" ] && DESTDIR=/opt/AGL/xds/agent
 [ -z "$TMPDIR" ] && TMPDIR=/tmp
 [ -z "$GOOS" ] && GOOS=$(go env GOOS)
 [ -z "$GOARCH" ] && GOARCH=$(go env GOARCH)
@@ -43,15 +60,25 @@ if [ "$?" != 0 ]; then
     exit 1
 fi
 
-gpg -q --keyserver pool.sks-keyservers.net --recv-keys 37C84554E7E0A261E4F76E1ED26E6ED000654A3E || exit 1
+# Workaround about issue with the particular GPG keyserver:
+# trying several explicit keyservers until the command succeeds
+# (see https://github.com/jacobalberty/unifi-docker/issues/64)
+for server in $(shuf -e pool.sks-keyservers.net \
+                        ha.pool.sks-keyservers.net \
+                        hkp://p80.pool.sks-keyservers.net:80 \
+                        keyserver.ubuntu.com \
+                        hkp://keyserver.ubuntu.com:80 \
+                        pgp.mit.edu) ; do
+    ${GPG} -q --keyserver "$server" --recv-keys 37C84554E7E0A261E4F76E1ED26E6ED000654A3E && break || :
+done
 
 tarball="syncthing-${GOOS_ST}-${GOARCH}-v${SYNCTHING_VERSION}.${TB_EXT}" \
-       && curl -sfSL "https://github.com/syncthing/syncthing/releases/download/v${SYNCTHING_VERSION}/${tarball}" -O \
-    && curl -sfSL "https://github.com/syncthing/syncthing/releases/download/v${SYNCTHING_VERSION}/sha1sum.txt.asc" -O \
-       && gpg -q --verify sha1sum.txt.asc \
-       && grep -E " ${tarball}\$" sha1sum.txt.asc | sha1sum -c - \
-       && rm -rf sha1sum.txt.asc syncthing-${GOOS_ST}-${GOARCH}-v${SYNCTHING_VERSION}
-       if [ "${TB_EXT}" = "tar.gz" ]; then
+    && curl --connect-timeout 60 --retry 3 -sfSL "https://github.com/syncthing/syncthing/releases/download/v${SYNCTHING_VERSION}/${tarball}" -O \
+    && curl --connect-timeout 60 --retry 3 -sfSL "https://github.com/syncthing/syncthing/releases/download/v${SYNCTHING_VERSION}/sha1sum.txt.asc" -O \
+    && gpg -q --verify sha1sum.txt.asc \
+    && grep -E " ${tarball}\$" sha1sum.txt.asc | sha1sum -c - \
+    && rm -rf sha1sum.txt.asc syncthing-${GOOS_ST}-${GOARCH}-v${SYNCTHING_VERSION}
+    if [ "${TB_EXT}" = "tar.gz" ]; then
         tar -xvf "$tarball" --strip-components=1 "$(basename "$tarball" .tar.gz)"/syncthing \
         && mv syncthing ${DESTDIR}/syncthing || exit 1
     else
@@ -85,7 +112,7 @@ if [ "$SYNCTHING_INOTIFY_VERSION" = "master" ]; then
 else
 
     tarball="syncthing-inotify-${GOOS_STI}-${GOARCH}-v${SYNCTHING_INOTIFY_VERSION}.${TB_EXT}"
-    curl -sfSL "https://github.com/syncthing/syncthing-inotify/releases/download/v${SYNCTHING_INOTIFY_VERSION}/${tarball}" -O || exit 1
+    curl --connect-timeout 60 --retry 3 -sfSL "https://github.com/syncthing/syncthing-inotify/releases/download/v${SYNCTHING_INOTIFY_VERSION}/${tarball}" -O || exit 1
     rm -rf syncthing-inotify-${GOOS_STI}-${GOARCH}-v${SYNCTHING_INOTIFY_VERSION}
     if [ "${TB_EXT}" = "tar.gz" ]; then
         tar -xvf "${tarball}" syncthing-inotify && mv syncthing-inotify ${DESTDIR}/syncthing-inotify || exit 1
@@ -94,4 +121,4 @@ else
     fi
 fi
 
-echo "DONE: syncthing and syncthing-inotify successfuly installed in ${DESTDIR}"
\ No newline at end of file
+echo "DONE: syncthing and syncthing-inotify successfuly installed in ${DESTDIR}"